#ifndef __bdd__
#define __bdd__

#include <wx/filefn.h>
#include <wx/file.h>
#include <wx/ffile.h>
#include <wx/msgdlg.h>
#include <wx/progdlg.h>
#include <wx/grid.h>
#include <wx/utils.h>
#include <sqlite3.h>
#include "misc.h"

class class_bdd
{
	private:
		sqlite3* db;
		sqlite3_stmt* stmt, *stmt_correc;
		int rc;
		wxGrid* grid_consults;
		wxString path_in;
		
		void CreateEmpty(const wxString& path);
	public:
		class_bdd(const wxString& path_in, wxGrid* grid_consults);
		~class_bdd();
		
		// import/export
		void Importer(const wxString& filename);
		void Exporter(const wxString& filename);
		
		// mise à jour de la grille
		void GenerateGrid();
		
		// modification des booléens de publi
		void SetResultPubli(int row, unsigned int bitfield);							//(publi(1<<1)/publichu(1<<2)/cs_associe(1<<3)
		
		// gestion des corrections
		wxArrayString* GetListCorrecs();
		void AddCorrec(const wxString& id, int col, const wxString& dest);
		void SetCorrec(const wxString& orig, const wxString& dest);
		void DelCorrec(const wxString& orig);
		
		// gestion des résultats
		int GetNbResults(const wxString& id);
		void SetNbResults(const wxString& id, int nb_results);
		wxArrayString GetIdResult(const wxString& id, bool stripped=false);
		void SetIdResult(const wxString& id, wxArrayString id_results);
		void AddIdResult(const wxString& id, const wxString& id_result);
		
		// gestion des publis
		bool IsPubli(const wxString& id);
		void AddPubli(wxString id, wxString title, wxString authors, wxString abstract, wxString journal, wxString link, wxString date, wxString affiliation);
		wxArrayString GetPublis(wxString id);
};

#endif //__bdd__
