#ifndef __config__
#define __config__

#include <wx/xml/xml.h>
#include <wx/window.h>
#include <wx/filefn.h>
#include <vector>
#include "misc.h"

using namespace std;

typedef	struct trule
{
	wxString name;
	bool in_use;
	bool use_demandeur, use_responsable, use_consultant;
	int op_demandeur, op_both, op_responsable;
	bool use_debut, use_fin;
	int debut, fin;
	bool use_ville;
	wxString ville;
	bool use_suppl;
	wxString suppl;
	int retmax;
}rule;

class class_config
{
protected:
	bool is_first_time;
	wxString path_db;
	bool use_proxy;
	wxString proxy_url;
	int proxy_port;
	vector<rule> list_rules;
	
	void CreateDefault();
	void Load();
	void AddRulesToXML(wxXmlNode* setlistnode, rule to_add);
	
public:
	class_config();
	~class_config();
	
	void Save();
	void AddRule(rule to_add);
	void DelRule(int index);
	//TODO: GetListRules avec vector<rule>, éventuellement SetListRules, garder GetRule pour le fetch individuel
	int GetNbRules();
	rule GetRule(int index);
	void SetRule(int index, rule temp);
	void MoveRuleUp(int index);
	void MoveRuleDown(int index);
	
	// GETters et SETters
	void SetPathDb(const wxString& path_db) {this->path_db = path_db;}
	void SetProxyPort(int proxy_port) {this->proxy_port = proxy_port;}
	void SetProxyUrl(const wxString& proxy_url) {this->proxy_url = proxy_url;}
	void SetUseProxy(bool use_proxy) {this->use_proxy = use_proxy;}
	const wxString& GetPathDb() const {return path_db;}
	int GetProxyPort() const {return proxy_port;}
	const wxString& GetProxyUrl() const {return proxy_url;}
	bool IsUseProxy() const {return use_proxy;}
	bool IsFirstTime() const {return is_first_time;}
};


#endif // __config__
