#include "correc.h"

correc::correc( wxWindow* parent, class_bdd* bdd )
:
dialog_correc( parent )
{
	this->bdd = bdd;
}

void correc::Update()
{
	if (grid_correcs->GetNumberRows() != 0)
		grid_correcs->DeleteRows(0, grid_correcs->GetNumberRows()); //reset de la grille
	wxArrayString* list_correcs = bdd->GetListCorrecs();
	grid_correcs->AppendRows(list_correcs[0].Count());
	for (unsigned int i=0; i < list_correcs[0].Count(); i++)
	{
		grid_correcs->SetRowLabelValue(i, "X");
		grid_correcs->SetCellValue(i, 0, list_correcs[0][i]);
		grid_correcs->SetCellValue(i, 1, list_correcs[1][i]);
	}
	grid_correcs->AutoSizeRows(false);
	grid_correcs->AutoSizeColumns(false);
	Fit();
	delete[] list_correcs;
}

void correc::OnCellChange( wxGridEvent& event )
{
	int row = event.GetRow();
	bdd->SetCorrec(grid_correcs->GetCellValue(row, 0), grid_correcs->GetCellValue(row, 1));
}

void correc::OnLabelLeftClick( wxGridEvent& event )
{
	if (event.GetRow() != -1)
	{
		wxString orig = grid_correcs->GetCellValue(event.GetRow(), 0);
		bdd->SetCorrec(orig, orig);
		grid_correcs->DeleteRows(event.GetRow(), 1, false);
	}
}

void correc::OnOk( wxCommandEvent& event )
{
	Close();
}

void correc::OnClose( wxCloseEvent& event )
{
	Show(false);
}