#include "cosmos.h"

cosmos::cosmos( wxWindow* parent )
:
cosmosGUI( parent )
{
	config = new class_config();
	fenetre_options = new options(this, config);
	fenetre_optionsRche = new optionsRche(this, config);
	
	if (config->IsFirstTime())
	{
		wxMessageBox(_T("Vous lancez CosMoS pour la première fois,\nveuillez configurer le chemin de la base\nainsi que les paramètres de connexion"));
		fenetre_options->ShowModal();
		wxMessageBox(_T("Vous pouvez également commencer à créer des sets d'options de recherche"));
		fenetre_optionsRche->ShowModal();
	}

	bdd = new class_bdd(config->GetPathDb(), grid_consults);
	bdd->GenerateGrid();
	fenetre_corrections = new correc(this, bdd);
	recherche = new class_recherche(config, bdd, grid_consults);
	fenetre_resultats = new resultats(this, bdd, grid_consults);
}

void cosmos::OnImport( wxCommandEvent& event )
{
	wxFileDialog * dialog_open = new wxFileDialog(this, "Importer", "", "", "*.csv", wxFD_OPEN | wxFD_FILE_MUST_EXIST);
	
	if (dialog_open->ShowModal() == wxID_CANCEL)
		return;
	else
		bdd->Importer(dialog_open->GetPath());
	
	delete dialog_open;
}

void cosmos::OnExport( wxCommandEvent& event )
{
	wxFileDialog * dialog_save = new wxFileDialog(this, "Exporter", "", "", "*.csv", wxFD_SAVE);
	
	if (dialog_save->ShowModal() == wxID_CANCEL)
		return;
	else
		bdd->Exporter(dialog_save->GetPath());
	
	delete dialog_save;
}

void cosmos::OnQuit( wxCommandEvent& event )
{
	Close();
}

void cosmos::OnQuit( wxCloseEvent& event )
{
	delete fenetre_resultats;
	delete recherche;
	delete fenetre_corrections;
	delete bdd;
	delete fenetre_options;
	delete config;
	exit(0);
}

void cosmos::OnStart( wxCommandEvent& event )
{
	recherche->Start();
}

void cosmos::OnOptionsRche( wxCommandEvent& event )
{
	fenetre_optionsRche->ShowModal();
}

void cosmos::OnCorrections( wxCommandEvent& event )
{
	fenetre_corrections->Update();
	fenetre_corrections->ShowModal();
}

void cosmos::OnSearch( wxCommandEvent& event )
{
// TODO: Implement OnSearch
}

void cosmos::OnOptionsProg( wxCommandEvent& event )
{
	fenetre_options->ShowModal();
}

void cosmos::OnCellChange( wxGridEvent& event )
{
	int row = event.GetRow();
	int col = event.GetCol();
	bdd->AddCorrec(grid_consults->GetCellValue(row, 13), col, grid_consults->GetCellValue(row, col));
}
	
void cosmos::OnCellDbClick( wxGridEvent& event )
{
	fenetre_resultats->SetCurrentRowConsult(event.GetRow());
	fenetre_resultats->Update();
	fenetre_resultats->Show();
}