#include "options.h"

options::options( wxWindow* parent, class_config* config )
:
dialog_Options( parent )
{
	this->config = config;
	dirpicker_dbpath->SetPath(config->GetPathDb());
	checkbox_proxy->SetValue(config->IsUseProxy());
	textctrl_url->SetValue(config->GetProxyUrl());
	spinctrl_port->SetValue(config->GetProxyPort());
	UpdateUI();
}

options::~options()
{
}

void options::OnCancel( wxCloseEvent& event )
{
	dirpicker_dbpath->SetPath(config->GetPathDb());
	checkbox_proxy->SetValue(config->IsUseProxy());
	textctrl_url->SetValue(config->GetProxyUrl());
	spinctrl_port->SetValue(config->GetProxyPort());
	Show(false);
	UpdateUI();
}

void options::OnCancel( wxCommandEvent& event )
{
	Close();
}

void options::OnOk( wxCommandEvent& event )
{
	config->SetPathDb(dirpicker_dbpath->GetPath());
	config->SetUseProxy(checkbox_proxy->GetValue());
	config->SetProxyUrl(textctrl_url->GetValue());
	config->SetProxyPort(spinctrl_port->GetValue());
	config->Save();
	Show(false);
}

void options::OnToggleProxy( wxCommandEvent& event )
{
	UpdateUI();
}

void options::UpdateUI()
{
	if (!checkbox_proxy->GetValue())
	{
		textctrl_url->Disable();
		spinctrl_port->Disable();
	}
	else
	{
		textctrl_url->Enable();
		spinctrl_port->Enable();
	}
}
