#include "resultats.h"

resultats::resultats( wxWindow* parent, class_bdd* bdd, wxGrid* grid_consults )
:
dialog_resultats( parent )
{
	this->bdd = bdd;
	this->grid_consults = grid_consults;
	changed = false;
}

void resultats::OnCellClick( wxGridEvent& event )
{
	current_row_publi = event.GetRow();
	grid_publis->GoToCell(current_row_publi,0);
	grid_publis->SetGridCursor(current_row_publi,0);
	grid_publis->SelectRow(current_row_publi);
	UpdateUI();
}

void resultats::OnCheckPubli( wxCommandEvent& event )
{
	if (event.GetId() == CHK_PUBLI)
	{
		bool was_publi = (list_publi[current_row_publi].Left(1) == '@');
		list_publi[current_row_publi] = list_publi[current_row_publi].AfterLast('!').AfterLast('@');
		switch (checkbox_publi->Get3StateValue())
		{
			case wxCHK_CHECKED:
				list_publi[current_row_publi] = "@" + list_publi[current_row_publi];
				grid_publis->SetCellBackgroundColour(current_row_publi, 0, *wxGREEN);
				if (!was_publi)
					nb_publi++;
			break;
			
			case wxCHK_UNDETERMINED:
				list_publi[current_row_publi] = "!" + list_publi[current_row_publi];
				grid_publis->SetCellBackgroundColour(current_row_publi, 0, *wxLIGHT_GREY);
				if (was_publi)
					nb_publi--;
			break;
			
			case wxCHK_UNCHECKED:
				grid_publis->SetCellBackgroundColour(current_row_publi, 0, grid_publis->GetDefaultCellBackgroundColour());
				if (was_publi)
					nb_publi--;
			break;
			
			default:break;
		}
	}
	changed = true;
	UpdateCheckUI();
}

void resultats::OnPrev( wxCommandEvent& event )
{
	if (changed)
		Commit();
	changed = false;
	current_row_consult--;
	Update();
}

void resultats::OnNext( wxCommandEvent& event )
{
	if (changed)
		Commit();
	changed = false;
	current_row_consult++;
	Update();
}

void resultats::OnOk( wxCommandEvent& event )
{
	Close();
}

void resultats::OnClose( wxCloseEvent& event )
{
	if (changed)
		Commit();
	changed = false;
	Show(false);
}

void resultats::Update()
{
	nb_publi=0;
	current_id_consult = grid_consults->GetCellValue(current_row_consult, 13);
	list_publi.Clear();
	list_publi = bdd->GetIdResult(current_id_consult);
	
	if (grid_publis->GetNumberRows() != 0)
		grid_publis->DeleteRows(0, grid_publis->GetNumberRows()); //reset de la grille
		
	if (list_publi.GetCount() > 0)
	{
		grid_publis->AppendRows(list_publi.GetCount());
		for (unsigned int i=0; i < list_publi.GetCount(); i++)
		{
			wxString publi_id = list_publi[i];
			if (publi_id.Left(1) == "!")
			{
				publi_id = publi_id.AfterFirst('!');
				grid_publis->SetCellBackgroundColour(i, 0, *wxLIGHT_GREY);
			}
			else if (publi_id.Left(1) == "@")
			{
				nb_publi++;
				publi_id = publi_id.AfterFirst('@');
				grid_publis->SetCellBackgroundColour(i, 0, *wxGREEN);
			}
			else
				grid_publis->SetCellBackgroundColour(i, 0, grid_publis->GetDefaultCellBackgroundColour());
				
			grid_publis->SetCellValue(i, 0, publi_id);
		}
		
		current_row_publi = 0;
		grid_publis->SelectRow(current_row_publi);
		grid_publis->SetFocus();
		if (grid_consults->GetCellValue(current_row_consult,2) == "1")
			checkbox_publichu->SetValue(true);
		else
			checkbox_publichu->SetValue(false);
		if (grid_consults->GetCellValue(current_row_consult,3) == "1")
			checkbox_cs->SetValue(true);
		else
			checkbox_cs->SetValue(false);
		UpdateUI();
	}
	else
	{
		textctrl_titre->SetValue("");
		textctrl_auteurs->SetValue("");
		textctrl_abstract->SetValue("");
		textctrl_revue->SetValue("");
		statictext_date->SetLabel("Date de publication : ");
		hyperlink_lien->SetURL("");
		hyperlink_lien->Disable();
		textctrl_affiliation->SetValue("");
		checkbox_publi->Set3StateValue(wxCHK_UNCHECKED);
		checkbox_publi->Disable();
		checkbox_publichu->Disable();
		checkbox_cs->Disable();
	}
	if (current_row_consult == 0)
		bouton_prec->Disable();
	else
		bouton_prec->Enable();
	if (current_row_consult == (grid_consults->GetNumberRows() - 1))
		bouton_suiv->Disable();
	else
		bouton_suiv->Enable();
	grid_consults->SelectRow(current_row_consult);
	grid_consults->GoToCell(current_row_consult,0);
}

void resultats::UpdateUI()
{
	wxArrayString detail_publi = bdd->GetPublis(grid_publis->GetCellValue(current_row_publi, 0));
	textctrl_titre->SetValue(detail_publi[0]);
	textctrl_auteurs->SetValue(detail_publi[1]);
	textctrl_abstract->SetValue(detail_publi[2]);
	textctrl_revue->SetValue(detail_publi[3]);
	statictext_date->SetLabel("Date de publication : " + detail_publi[5]);
	hyperlink_lien->Enable();
	hyperlink_lien->SetURL(detail_publi[4]);
	textctrl_affiliation->SetValue(detail_publi[6]);
	checkbox_publi->Enable();
	wxCheckBoxState etat;
	if (list_publi[current_row_publi].Left(1) == "!")
		etat = wxCHK_UNDETERMINED;
	else if (list_publi[current_row_publi].Left(1) == '@')
		etat = wxCHK_CHECKED;
	else
		etat = wxCHK_UNCHECKED;
	checkbox_publi->Set3StateValue(etat);
	
	UpdateCheckUI();
}

void resultats::UpdateCheckUI()
{
	if (nb_publi > 0)
	{
		checkbox_publichu->Enable();
		checkbox_cs->Enable();
		this->Refresh();
	}
	else
	{
		checkbox_publichu->SetValue(false);
		checkbox_cs->SetValue(false);
		checkbox_publichu->Disable();
		checkbox_cs->Disable();
	}
}

void resultats::Commit()
{
	unsigned int bitfield = 0;
	if (nb_publi > 0)
		bitfield |= 1<<1;
	if (checkbox_publichu->GetValue())
		bitfield |= 1<<2;
	if (checkbox_cs->GetValue())
		bitfield |= 1<<3;
	bdd->SetResultPubli(current_row_consult, bitfield);
	bdd->SetIdResult(current_id_consult, list_publi);
	grid_consults->SetCellValue(current_row_consult, 0, _itoW(bdd->GetNbResults(current_id_consult)));
}

void resultats::OnKey( wxKeyEvent& event )
{
	if ((event.GetKeyCode() != WXK_SPACE) && (checkbox_publi->Get3StateValue() == wxCHK_UNCHECKED) && (list_publi.GetCount() > 0))
	{
		list_publi[current_row_publi] = "!" + list_publi[current_row_publi];
		grid_publis->SetCellBackgroundColour(current_row_publi, 0, *wxLIGHT_GREY);
		checkbox_publi->Set3StateValue(wxCHK_UNDETERMINED);
		changed = true;
	}
	
	if ((event.GetKeyCode() == WXK_UP) && (current_row_publi>0))
	{
		current_row_publi--;
		grid_publis->MoveCursorUp(false);
		grid_publis->SelectRow(current_row_publi);
		UpdateUI();
	}
	
	if ((event.GetKeyCode() == WXK_DOWN) && (current_row_publi < grid_publis->GetNumberRows() - 1))
	{
		current_row_publi++;
		grid_publis->MoveCursorDown(false);
		grid_publis->SelectRow(current_row_publi);
		UpdateUI();
	}
	wxCommandEvent e;
	
	if ((event.GetKeyCode() == WXK_LEFT) && (current_row_consult>0))
	{
		if (changed)
			Commit();
		changed = false;
		do
		{
			current_row_consult--;
			
		}while ((current_row_consult > 0) && (wxAtoi(grid_consults->GetCellValue(current_row_consult, 0)) == 0));
		Update();
		
		if (current_row_consult == 0)
			wxMessageBox(_T("Début de la liste de consultations"));
	}
	
	if ((event.GetKeyCode() == WXK_RIGHT) && (current_row_consult < grid_consults->GetNumberRows() - 1))
	{
		if (changed)
			Commit();
		changed = false;
		do
		{
			current_row_consult++;
		}while ((current_row_consult < grid_consults->GetNumberRows() - 1) && (wxAtoi(grid_consults->GetCellValue(current_row_consult, 0)) == 0));
		Update();
		
		if (current_row_consult == grid_consults->GetNumberRows() - 1)
			wxMessageBox(_T("Fin de la liste de consultations"));
	}
		
	if ((event.GetKeyCode() == WXK_SPACE) && (list_publi.GetCount() > 0))
	{
		if (checkbox_publi->Get3StateValue() != wxCHK_CHECKED)
		{
			list_publi[current_row_publi] = list_publi[current_row_publi].AfterLast('!');
			list_publi[current_row_publi] = "@" + list_publi[current_row_publi];
			grid_publis->SetCellBackgroundColour(current_row_publi, 0, *wxGREEN);
			checkbox_publi->Set3StateValue(wxCHK_CHECKED);
			nb_publi++;
		}
		else
		{
			list_publi[current_row_publi] = list_publi[current_row_publi].AfterLast('@');
			grid_publis->SetCellBackgroundColour(current_row_publi, 0, grid_publis->GetDefaultCellBackgroundColour());
			checkbox_publi->Set3StateValue(wxCHK_UNCHECKED);
			nb_publi--;
		}
		changed = true;
		UpdateCheckUI();
	}
}